<script type="text/javascript">
    mixpanel.track("About")
</script>
<div class='clear'></div>

## About 

What if the whole web is an API waiting to be consumed? APIfy brings to life all the data that is locked up in HTML tables and Wiki pages in the form of JSON APIs.

### What is APIfy for?

APIfy is not about large datasets. It is about smaller datasets for which there are no APIs like: 

* IMDB Top 250 movies
* Time Top 100 books
* List of all your favorite TV show episodes
* Bus/Train routes in your city
* Sports schedules

Everytime you've used a list box of countries, states, timezones in HTML forms and wished someone had an API for it... 

Everytime you wanted an API of your favorite tv show episodes to make a mobile app and rate them...

Or a Periodic table API to make a geeky game...   

### How does APIfy work?

APIfy extracts data from structured markups and converts it to JSON APIs. It caches JSON to make them insanely fast. The APIs can be called from Ruby/Python/Node.js/Mobile apps or directly from Javascript using JSONP. 

The next time you make an iPhone app to track all the Oscar winning movies you've seen, you can make API calls like:

* apify.heroku.com/api/oscar_movies.json
* apify.heroku.com/api/oscar_movies.json?director=stanley_kubrick
* apify.heroku.com/api/oscar_movies/123.json   

### Get Started

APIfy is a set of community contributed APIs. To get started, check out these tutorials:

* [Create API](/tutorial/create)
* [Use API](/tutorial/use)
* Start [creating your own APIs](/resources/new)

### Terms of Use

APIfy and its creators are not responsible for any user generated content.

Wikipedia, Blogs and Public service sites which don't have an API are OK.
For any other site read the Terms of Use carefully before using it. 

Any API that is a violation of the original site's Terms of Use will be removed from APIfy.